from simpleLA import *
#--------スタック関連--------------
stack=[]
def push(A):
    global stack;stack.append(A)
def pop():
    global stack;NUM=len(stack)
    if NUM<=0: print("stack empty"); return []
    NUM-=1;R=stack[NUM]; del stack[NUM]
    return R
def empty():global stack; return stack==[]
def notEmpty():global stack; return stack!=[]
#---------構文解析関連----------------
def getOpt(SH):#■演算優先度の取り出し
    opt=[[",",10],["|",16],["&",16],["^",16],["!",17],
         [">",18],[">=",18],["<",18],["<=",18],["==",18],["!=",18],
         ["=",12],["+",20],["-",20],["*",30],["/",30],["%",30],
         ["+$",40],["-$",40],["**",50],["(",0],[")",0]]
    for i in range(len(opt)):
        if opt[i][0]==SH: return opt[i][1]
    return -999  #演算子エラー(ただし，正常ならありえない)
def procSA(LA):#■構文解析
    NUM=len(LA);out=[]
    for i in range(NUM):
        if   LA[i][0]=="func": push([LA[i],100])
        elif LA[i][0]=="delm":
            if   LA[i][1]=="(": push([LA[i],0])
            elif LA[i][1]==")":#左括弧までポップ
                while notEmpty():
                    DT=pop()
                    if DT[0][1]=="(": break
                    out.append(DT[0])
            else:
                OPT=getOpt(LA[i][1])#演算優先順位
                if OPT==-999:
                    print("演算子エラー", LA[i][1]); return []
                if empty(): push([LA[i],OPT])#スタック空のとき
                else:#スタック先頭の優先順位が等しいか大きければ
                    while notEmpty(): #スタックを出力領域に移す
                        DT=pop()
                        if DT[1]<OPT: push(DT);break
                        out.append(DT[0])
                    push([LA[i],OPT])
        else: out.append(LA[i])
    while notEmpty():DT=pop();out.append(DT[0])
    return out
def genTree(SA):#■構文木の生成
    global stack; stack=[]  #演算対象のときpush,関数名と演算子
    for i in range(len(SA)):#のとき，構文木を生成してpush
        if SA[i][0]=="numb" or SA[i][0]=="name": push(SA[i])
        elif SA[i][0]=="func": push([SA[i],pop()])#関数名
        elif SA[i][0]=="delm":#演算子(-$, +$は単項演算子の-, +）
            if  SA[i][1]=="-$" or SA[i][1]=="+$":push([SA[i],pop()])
            else: A=pop(); push([SA[i],pop(),A])# 2項演算子
    return pop()
def countNode(TR,C):#■ノード数(C=0 or 1 : C=0のときリーフ無視)
    if TR[0]=="numb" or TR[0]=="name":return C
    if TR[0][0]=="func": return countNode(TR[1],C)+1
    if TR[0][0]=="delm":
        if TR[0][1]=="-$" or TR[0][1]=="+$":
            return countNode(TR[1],C)+1
        return (countNode(TR[1],C)+
                countNode(TR[2],C)+1)
def printPolish(Title,SA):#■逆ポーランド記法表示
    S=""
    for i in range(len(SA)):
        if SA[i][0]=="func":S+="$"+SA[i][1]
        else:S+=SA[i][1]
    print(Title,S)
PTREE=[]
def prTree(TR,S):#■構文木表示("|"文字を除く)
    global PTREE
    if TR[0]=="numb" or TR[0]=="name":
        PTREE.append(S+"("+TR[1]+")")
    elif TR[0][0]=="func":
        prTree(TR[1],S+"f("+TR[0][1]+")-")
    elif TR[0][0]=="delm":
        if TR[0][1]=="-$" or TR[0][1]=="+$":
            prTree(TR[1],S+"o("+TR[0][1]+")-")
        else:
            SS= S+"o("+TR[0][1]+")-"
            prTree(TR[1],SS)
            PTREE.append(" " *(len(SS)+10))
            prTree(TR[2],(" " *(len(SS)-3)+"+--"))
def replaceStr(S,CH,jj):#■文字列の置き換え
    R=""
    for k in range(len(S)):
        if k==jj: R+=CH
        else: R+=S[k]
    return R
def printTree(TR):#■構文木表示メイン
    global PTREE; PTREE=[]
    print("\n")
    prTree(TR,"   ")
    for i in range(2,len(PTREE),2):# "|"文字の設定
        jj=0
        for j in range(len(PTREE[i])):
            if PTREE[i][j]!=" ":jj=j; break
        if jj!=0 and PTREE[i][jj]=="+":
            for k in range(i-1,0,-1):
                if PTREE[k][jj]!=" ":break
                PTREE[k]=replaceStr(PTREE[k],"|",jj)
    for i in range(len(PTREE)):print(PTREE[i])
